unit uCreateUniqueName;
{< this unit contains methods that will Create Unique Name}

interface

uses
  System.SysUtils, System.Classes, vcl.dialogs,
  System.RegularExpressions,uSortStringList;

type
  TCreateUniqueName = class(TDataModule)
  private


    { Private declarations }
  public
    { Public declarations }

  class function CreateUniqueNameAddingGUID(

    FileName:string;
    MaxOriginNameLength:Integer


    ):string;
    {< CreateUniqueNameAddingGUID - all clear from the name. This is class function}



    class function AddParamAndValueToName(FileName,
    Param,
    Value: string):

    string; static;

    {<this will add Param=Value to someName }

    class function GetParamValueFromFileName(FileName: string; const ParamName: string):string; static;
    {<this will get ParamValue from Name }

  end;

var
  CreateUniqueName: TCreateUniqueName;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TCreateUniqueName }

{Creating New Unique Name with a rest of old name, using GUID}
class function TCreateUniqueName.CreateUniqueNameAddingGUID(FileName: string; MaxOriginNameLength: Integer): string;

var
    Extension:string;
    SplittedString: TArray<String>;
    SomeStringToChange: string;
    newguid:tguid;
    i: Integer;

    FileNameTemp:string;

begin

//Checks
if FileName='' then Exit;
//if MaxOriginNameLength=0 then exit;  // if MaxOriginNameLength=0 will be only GUID as a result


//1--------- First of all we need to extract extension if it is
SplittedString:=FileName.Split(['.']);

    //we suppose that extensions are symbols after last '.', so...

    // if FileName has extension like 'SomeFileName.exe'

    if Length(SplittedString)>0 //1 and more, for example somename.ext [somename,ext]
    then

begin
    Extension:=SplittedString[ High(SplittedString)  ];


    //Lets join everything except extension
      for i := Low(SplittedString) to High(SplittedString)-1 do
         begin

         if i=0 then
         SomeStringToChange:=SomeStringToChange+SplittedString[i] else
         SomeStringToChange:=SomeStringToChange+'.'+SplittedString[i];
         end;

         //Cutting name up to the MaxOriginNameLength
      if Length( SomeStringToChange )> MaxOriginNameLength then
      SomeStringToChange:=SomeStringToChange.Substring(0,MaxOriginNameLength);

      //Adding GUID
      Createguid(newguid);
      SomeStringToChange:=SomeStringToChange+newguid.ToString;

      // Joining Extension
      SomeStringToChange:=SomeStringToChange+'.'+Extension;

      Result:=SomeStringToChange;

end else

     // if FileName without Extension like 'SomeFileName'
     if Length(SplittedString)=0 then

     begin

     FileNameTemp:=FileName;


      //Cutting name up to the MaxOriginNameLength
      if Length( FileNameTemp )> MaxOriginNameLength then
      FileNameTemp:=FileNameTemp.Substring(0,MaxOriginNameLength);

      //Adding GUID
      Createguid(newguid);
      FileNameTemp:=FileNameTemp+newguid.ToString;


      Result:=FileNameTemp;
     end;

//ShowMessage(Result);
end;



// {Adding Params to FileName, so FileName.exe will be FileName{Param=Value}.exe }
class function TCreateUniqueName.AddParamAndValueToName(FileName: string; Param:string; Value:string ): string;

var
    Extension:string;
    SplittedString: TArray<String>;
    SomeStringToChange:string;
    i: Integer;

    FileNameTemp:string;

begin

//Checks
if FileName='' then Exit;



//1--------- First of all we need to extract extension if it is
SplittedString:=FileName.Split(['.']);

    //we suppose that extensions are symbols after last '.', so...

    // if FileName has extension like 'SomeFileName.exe'

    if Length(SplittedString)>1 //2 and more, for example somename.ext [somename,ext]
    then

begin
    Extension:=SplittedString[ High(SplittedString)  ];


//ShowMessage(Extension); // for test

//2----------Now lets change previous massive Element if it is

      SomeStringToChange:=SplittedString[ High(SplittedString)-1  ];


      //Adding Param And Value
      SomeStringToChange:=SomeStringToChange+'{'+Param+'='+Value+'}';
      SplittedString[ High(SplittedString)-1  ]:=SomeStringToChange;

//3-------Now our name is Unique we can join it back
                Result:='';

                for i := Low(SplittedString) to High(SplittedString)-1 do
                Result:=Result+SplittedString[i]+'.';

                //At last adding Extension
                Result:=Result+Extension;


end else

     // if FileName without Extension like 'SomeFileName'
     if Length(SplittedString)=1 then

     begin

     FileNameTemp:=FileName;
     FileNameTemp:=FileNameTemp+'{'+Param+'='+Value+'}';

      Result:=FileNameTemp;
     end;

//ShowMessage(Result); //for test
end;


{Get Param Value from FileName}
class function TCreateUniqueName.GetParamValueFromFileName(FileName: string; const ParamName:string):string;

var

     RegEx:TRegEx;
     M: TMatchCollection;
     M2: TMatchCollection;
     M3: TMatchCollection;

begin

Result:='';

M:=RegEx.Matches( FileName ,'{'+ParamName+'=[\w\d]*}');//chunkNumber=[\w\d]*[\d]\b //chunkNumber=[\w]*[\d]\b
if M.Count>0 then M2:=RegEx.Matches( M.Item[M.Count-1].Value ,'=[\w\d]*');
if M2.Count>0 then M3:=RegEx.Matches( M2.Item[M2.Count-1].Value ,'[\w\d]*');
if M3.Count>0
     then
         Result:=M3.Item[M3.Count-1].Value;


end;


end.
