unit uSendFileInChunksThread;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,Contnrs,SyncObjs,System.IOUtils,

  //myUnits
  uVisualFrame,uUploadFrame,uSendFileInChunks

  ;

type
  TSendFileInChunksThread = class(TThread)
  private
    { Private declarations }


    FFilePath:string;
    FMaxCountBytes:Int64;

    FGuidString:string;

    FUploadFrame:TUploadFrame;

    FUploadFrameOL:TObjectList;
    FUploadThreadsOL:TObjectList;

    FVisualFrame:TVisualFrame_HTTP;

    FSendFileInChunks:TSendFileInChunks;

    FIsKeep2Share:boolean;


    fEx : Exception;
    procedure QueryError;

    procedure OnUploadInChunksBegin(Sender: TObject; ACountBytes:Int64);
    procedure OnUploadInChunks(Sender: TObject; ACountBytes:Int64);

    function  GetFilePath:string;
    procedure SetFilePath(AValue:string);

    function  GetVisualFrame:TVisualFrame_HTTP;
    procedure SetVisualFrame(AValue:TVisualFrame_HTTP);


    function  GetGUIDString:string;
    procedure SetGUIDString(AValue:string);


    function  GetUploadFrame:TUploadFrame;
    procedure SetUploadFrame(AValue:TUploadFrame);


    function  GetUploadFrameOL:TObjectList;
    procedure SetUploadFrameOL(AValue:TObjectList);


    function  GetUploadThreadOL:TObjectList;
    procedure SetUploadThreadOL(AValue:TObjectList);

    procedure myOnTerminate(Sender:TObject);



  public


  property IsKeep2Share:boolean read FIsKeep2Share write FIsKeep2Share;


  property FilePath:string read GetFilePath write SetFilePath;
  property VisualFrame:TVisualFrame_HTTP read GetVisualFrame write SetVisualFrame;
  property Guidstring:string read GetGUIDString write SetGUIDString;
  property UploadFrameOL:TObjectList read GetUploadFrameOL write SetUploadFrameOL;
  property UploadThreadOL:TObjectList read GetUploadThreadOL write SetUploadThreadOL;

  property SendFileInChunks:TSendFileInChunks read FSendFileInChunks write FSendFileInChunks;

 // property UploadFrame:TUploadFrame  read GetUploadFrame write SetUploadFrame;

  property UploadFrame:TUploadFrame  read FUploadFrame write FUploadFrame;

  //FUploadFrame

  protected

    procedure Execute; override;


  end;

implementation

//uses  ;


{
  Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TSendFileInChunksThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end;

    or

    Synchronize(
      procedure
      begin
        Form1.Caption := 'Updated in thread via an anonymous method'
      end
      )
    );

  where an anonymous method is passed.

  Similarly, the developer can call the Queue method with similar parameters as
  above, instead passing another TThread class as the first parameter, putting
  the calling thread in a queue with the other thread.

}

{ TSendFileInChunksThread }

procedure TSendFileInChunksThread.Execute;


var   ChunkSize:Int64;
//      SendFileInChunks: TSendFileInChunks;


begin
  { Place thread code here }


   //  SendFileInChunks:=TSendFileInChunks.Create(FVisualFrame);
  //   SendFileInChunks.CS:=FVisualFrame.CS; // giving link to critical section

  Self.OnTerminate:=myOnTerminate;

   try

         FVisualFrame.CS2.Enter;
         try

         //Firing Event
         if Assigned(FVisualFrame.OnKeep2ShareStartUpload) and (FIsKeep2Share) then
         FVisualFrame.OnKeep2ShareStartUpload(Self);

         SendFileInChunks.OnUploadInChunksBegin:=OnUploadInChunksBegin;
         SendFileInChunks.OnUploadInChunks:=OnUploadInChunks;
     //    SendFileInChunks.SomeThread:=Self;


         ChunkSize:=4*1024*1024; // 1mb
         SendFileInChunks.IsKeep2Share:=FIsKeep2Share;


         SendFileInChunks.SendFileInChunks(FilePath,ChunkSize);


         if Assigned(FVisualFrame.OnKeep2ShareEndUpload) and (FIsKeep2Share) then

          begin

          FVisualFrame.LinksOnKeep2Share.Add(

            //SendFileInChunks.LinkKeep2Share

            FFilePath+'='+SendFileInChunks.LinkKeep2Share

           );

          // Firing event here
          FVisualFrame.OnKeep2ShareEndUpload(Self);

          end;


          {
         if FIsKeep2Share then

          begin

            FVisualFrame.LinksOnKeep2Share.Add(

            //SendFileInChunks.LinkKeep2Share

            FFilePath+'='+SendFileInChunks.LinkKeep2Share

           );

           if (FVisualFrame.LinksOnKeep2Share.Count<>0)
          // and (FVisualFrame.mLinks.ParentWindow<>0)

            then
          // FVisualFrame.mLinks.Lines.
          // add(FVisualFrame.LinksOnKeep2Share[FVisualFrame.LinksOnKeep2Share.Count-1]);



          end;

          }

         finally

         FVisualFrame.CS2.Leave;
         //FreeAndNil(SendFileInChunks);


         end;



   except

   fEx := ExceptObject as Exception;
   Synchronize( QueryError );

   end;





end;

function TSendFileInChunksThread.GetFilePath: string;
begin
 Result:=FFilePath;
 {
 FVisualFrame.CS2.Enter;
 try
 Result:=FFilePath;
 finally
 FVisualFrame.CS2.Leave;
 end;
 }
end;

function TSendFileInChunksThread.GetGUIDString: string;
begin
 Result:=FGuidString;
 {
 FVisualFrame.CS2.Enter;
 try
 Result:=FGuidString;
 finally
 FVisualFrame.CS2.Leave;
 end;
 }

end;

function TSendFileInChunksThread.GetUploadFrame: TUploadFrame;
begin
 Result:=FUploadFrame;
 {
 FVisualFrame.CS2.Enter;
 try
 Result:=FUploadFrame;
 finally
 FVisualFrame.CS2.Leave;
 end;
 }

end;

function TSendFileInChunksThread.GetUploadFrameOL: TObjectList;
begin

Result:=FUploadFrameOL;
{
 FVisualFrame.CS2.Enter;
 try
 Result:=FUploadFrameOL;
 finally
 FVisualFrame.CS2.Leave;
 end;
}

end;

function TSendFileInChunksThread.GetUploadThreadOL: TObjectList;
begin

 Result:=FUploadThreadsOL;

end;

function TSendFileInChunksThread.GetVisualFrame: TVisualFrame_HTTP;
begin
 Result:=FVisualFrame;
{
 FVisualFrame.CS2.Enter;
 try
 Result:=FVisualFrame;

 finally
 FVisualFrame.CS2.Leave;
 end;
}
end;


procedure TSendFileInChunksThread.myOnTerminate(Sender: TObject);
var
  I: Integer;
begin


//deleting link on thread from Object List
{
if Assigned(FUploadThreadsOL) then begin


                    for I := 0 to FUploadThreadsOL.Count-1  do

                     begin

                     if TSendFileInChunksThread(FUploadThreadsOL[i]).GuidString=
                        Self.FGuidString then
                        FUploadThreadsOL.Delete(i);

                     end;





end;

}

end;

procedure TSendFileInChunksThread.OnUploadInChunks(Sender: TObject; ACountBytes: Int64);


begin


if Assigned(FUploadFrameOL) then
  begin

 //   TFile.AppendAllText('SomeFile.txt','ACountBytes '+ACountBytes.ToString());

         Synchronize(
      procedure

    var
      I: Integer;
   begin
                if FMaxCountBytes<>0 then

              begin
                                    {

                     FUploadFrame.ProgressBar.Position:=
                                        Trunc( (ACountBytes/FMaxCountBytes)*100 );

                                        FUploadFrame.Edit.Text:=
                                       ( Trunc ( (ACountBytes/FMaxCountBytes)*100 ) ).ToString;

                                      }


                    for I := 0 to FUploadFrameOL.Count-1  do

                     begin

                     if Assigned(TUploadFrame(FUploadFrameOL[i])) then

                     begin


                     if TUploadFrame(FUploadFrameOL[i]).GuidString=
                        Self.FGuidString then
                                       begin


                                        TUploadFrame(FUploadFrameOL[i]).ProgressBar.Position:=
                                        Trunc( (ACountBytes/FMaxCountBytes)*100 );

                                        TUploadFrame(FUploadFrameOL[i]).Edit.Text:=
                                       ( Trunc ( (ACountBytes/FMaxCountBytes)*100 ) ).ToString;

                                       // FUploadFrame.Repaint;


                                       end;


                     end;

                     end;





              end;


      end
      )


  end;


end;

procedure TSendFileInChunksThread.OnUploadInChunksBegin(Sender: TObject; ACountBytes: Int64);



begin



if Assigned(FUploadFrameOL) then
  begin



          Synchronize(
      procedure

    var  I: Integer;

   begin

      //   FMaxCountBytes:=ACountBytes;
      //   FUploadFrame.ProgressBar.Max:=100;


        for I := 0 to FUploadFrameOL.Count-1  do

         begin

         if Assigned(TUploadFrame(FUploadFrameOL[i])) then
         begin



             if TUploadFrame(FUploadFrameOL[i]).GuidString=
                Self.FGuidString then

                               begin

                                FMaxCountBytes:=ACountBytes;
                                TUploadFrame(FUploadFrameOL[i]).ProgressBar.Max:=100; // norm on 100


                               end;
             end;


         end;







      end
      )




  end;


end;

procedure TSendFileInChunksThread.QueryError;
begin
Application.OnException( Self, fEx );
end;

procedure TSendFileInChunksThread.SetFilePath(AValue: string);
begin
 FFilePath:=AValue;
 {
 FVisualFrame.CS2.Enter;
 try
 FFilePath:=AValue;

 finally
 FVisualFrame.CS2.Leave;
 end;
 }

end;

procedure TSendFileInChunksThread.SetGUIDString(AValue: string);
begin

 FGuidString:=AValue;
 {
 FVisualFrame.CS2.Enter;
 try
 FGuidString:=AValue;

 finally
 FVisualFrame.CS2.Leave;
 end;
 }

end;

procedure TSendFileInChunksThread.SetUploadFrame(AValue: TUploadFrame);
begin

 FUploadFrame:=AValue;
 {
 FVisualFrame.CS2.Enter;
 try
 FUploadFrame:=AValue;

 finally
 FVisualFrame.CS2.Leave;
 end;
 }

end;

procedure TSendFileInChunksThread.SetUploadFrameOL(AValue: TObjectList);
begin

  FUploadFrameOL:=AValue;

 {
 FVisualFrame.CS2.Enter;
 try
 FUploadFrameOL:=AValue;

 finally
 FVisualFrame.CS2.Leave;
 end;
 }
end;

procedure TSendFileInChunksThread.SetUploadThreadOL(AValue: TObjectList);
begin

FUploadThreadsOL:=AValue;

end;

procedure TSendFileInChunksThread.SetVisualFrame(AValue: TVisualFrame_HTTP);
begin

 FVisualFrame:=AValue;
{
 FVisualFrame.CS2.Enter;
 try
 FVisualFrame:=AValue;

 finally
 FVisualFrame.CS2.Leave;
 end;
}

end;



end.
