unit uSendManyFilesInChunks;
{< this unit is to send many files in chunks;

On Create we have

     if (AOwner is TVisualFrame_HTTP)  then
     VisualFrame_HTTP:=(AOwner as TVisualFrame_HTTP);

     so be carefull here - give correct link

}

interface

uses
   Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
   Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,Contnrs,uSendFileInChunks,Vcl.Buttons;

type
  TSendManyFilesInChunks = class(TDataModule)
  private
       { Private declarations }

    FUploadThreadsOL:TObjectList;
    FUploadFrameOL:TObjectList;


    FUploadFrameNameNumber:Integer;

    FSendFileInChunks:TSendFileInChunks;

    FFilePathesToSend:TStringList;
    {<FilePathes of Files to be send on Server}

    FCurrrentThreadsCount:integer;
    FMaxThreadsCount:integer;

    FIsKeep2Share:Boolean;


    FLinkKeep2Share:string;

    FVisualMode:boolean;

    procedure FOnUploadFrameButtonClick(Sender: TObject);


  public
    { Public declarations }



    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;


    procedure SendFilesOnServer(AFilePathes: TStringList);
    {<SendFilesOnServer}


    property IsKeep2Share:Boolean read FIsKeep2Share write FIsKeep2Share;
    property VisualMode:boolean read FVisualMode write FVisualMode;
    property SendFileInChunks:TSendFileInChunks read FSendFileInChunks
    write FSendFileInChunks;

  end;

//var
//  SendManyFilesInChunks: TSendManyFilesInChunks;



implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses uVisualFrame,uSendFileInChunksThread,uUploadFrame;
var VisualFrame_HTTP:TVisualFrame_HTTP;

{$R *.dfm}

{ TSendManyFilesInChunks }

constructor TSendManyFilesInChunks.Create(AOwner: TComponent);
begin
  inherited;


      if (AOwner is TVisualFrame_HTTP)  then
      VisualFrame_HTTP:=(AOwner as TVisualFrame_HTTP);

//      FSendFileInChunks:=TSendFileInChunks.Create(VisualFrame_HTTP);

      FUploadFrameNameNumber:=0;


      FUploadThreadsOL:=TObjectList.Create;
      FUploadThreadsOL.OwnsObjects:=false; // threads will be destroyed automatically

      FUploadFrameOL:=TObjectList.Create;
      FUploadThreadsOL.OwnsObjects:=false;


      FFilePathesToSend:=TStringList.Create;



      FMaxThreadsCount:=5;




end;

destructor TSendManyFilesInChunks.Destroy;
begin

FreeAndNil(FUploadThreadsOL);
FreeAndNil(FUploadFrameOL);
FreeAndNil(FFilePathesToSend);



  inherited;
end;








procedure TSendManyFilesInChunks.FOnUploadFrameButtonClick(Sender: TObject);
var
  i: integer;
begin

// identificating sender thread
 if (Sender is tbitbtn) then

  if ( (Sender as tbitbtn).Parent is TUploadFrame ) then

  with ( (Sender as tbitbtn).Parent as TUploadFrame ) do begin

    for i:= FUploadThreadsOL.Count-1 downto 0  do
     begin

      if Guidstring=TSendFileInChunksThread(FUploadThreadsOL[i]).Guidstring  then

        // terminating sender thread
        begin

          if not TSendFileInChunksThread(FUploadThreadsOL[i]).Finished then
          begin

          VisualFrame_HTTP.IdHTTP.Disconnect;
          TSendFileInChunksThread(FUploadThreadsOL[i]).Terminate;
          TSendFileInChunksThread(FUploadThreadsOL[i]).WaitFor;
          TSendFileInChunksThread(FUploadThreadsOL[i]).Free;


          end;


        end;


     end;


  end;


end;

procedure TSendManyFilesInChunks.SendFilesOnServer(AFilePathes: TStringList);
var

  I,j,k: Integer;
  SendFileInChunksThread: TSendFileInChunksThread;
  UploadFrame:TUploadFrame;

  newguid:TGUID;
  newguidstring:string;


begin



  // Deleting finished threads
  for j:=FUploadThreadsOL.Count-1 downto 0 do begin

                    if TSendFileInChunksThread(FUploadThreadsOL[j]).Finished
                      then

                      begin

                      if FVisualMode  then
                      begin



                       // clearing FUploadFrameOL from finished ones...
                       for i := FUploadFrameOL.Count-1 downto 0  do
                         begin

                          if TSendFileInChunksThread(FUploadThreadsOL[j]).Guidstring=
                             TUploadFrame(FUploadFrameOL[i]).Guidstring then

                             TUploadFrame(FUploadFrameOL[i]).Free;



                         end;

                      end;

                      FUploadThreadsOL.Delete(j);

                      end;



  end;



// Checking Number of Threads

FCurrrentThreadsCount:=FUploadThreadsOL.Count;

 if  (FCurrrentThreadsCount+AFilePathes.Count>FMaxThreadsCount)

  then

     begin
     ShowMessage('    ('+
     FMaxThreadsCount.ToString+
     ')   .     ');
     Exit;
     end;









    for I := 0 to AFilePathes.Count-1 do
     begin

       Createguid(newguid);
       newguidstring:=newguid.ToString;

       if FVisualMode  then

       begin
            // Creating upload frames...

            j:=FUploadFrameOL.Add(TUploadFrame.Create(Self));

            with TUploadFrame(FUploadFrameOL[j]) do begin

              Name:='UploadFrame'+FUploadFrameNameNumber.ToString;
              Guidstring:=newguidstring;  // Objects are connected through guid
              Parent:=VisualFrame_HTTP.sbUploads;
              Align:=alTop;
              lFileName.Caption:=ExtractFileName(AFilePathes[i]);

              bAction.OnClick:=FOnUploadFrameButtonClick;



              Show;
              Inc(FUploadFrameNameNumber);

            end;
       end;



          //Creating Threads

           k:=FUploadThreadsOL.Add(TSendFileInChunksThread.Create(true));

           with TSendFileInChunksThread(FUploadThreadsOL[k]) do begin

           IsKeep2Share:=FIsKeep2Share;

           SendFileInChunks:=FSendFileInChunks;

           TSendFileInChunksThread(FUploadThreadsOL[k]).
           IsKeep2Share:=FIsKeep2Share;

           FreeOnTerminate:=true;
           FilePath:=AFilePathes[i];
           VisualFrame:=VisualFrame_HTTP;
           Guidstring:=newguidstring; // Objects are connected through guid

           if FVisualMode  then
            begin
            UploadFrame:=TUploadFrame(FUploadFrameOL[j]);

            UploadFrameOL:=FUploadFrameOL;
            UploadThreadOL:=FUploadThreadsOL;
            end;



           Start;

           end;


       end;





//  VisualFrame_HTTP.Repaint;
//  VisualFrame_HTTP.Refresh;
//  VisualFrame_HTTP.Realign;

//  VisualFrame_HTTP.sbUploads.Repaint;
//  VisualFrame_HTTP.sbUploads.Refresh;
    VisualFrame_HTTP.sbUploads.Realign;


end;


end.
