unit uVisualFrame;
{<uVisualFrame

this unit is central in component
all methods of developed component will be gathered here,

to call some method or property we should do following

 MyNewComponent.VisualFrame.SomeMethod
 or
 MyNewComponent.VisualFrame.SomeProperty

}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP,


  HTTPApp,
  IdMultipartFormData, FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf,
  FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.VCLUI.Wait, Data.DB,
  FireDAC.Comp.Client, System.IOUtils,IdIOHandlerStack,IdIOHandlerSocket,IdIOHandler,System.RegularExpressions,
  System.Types, System.SyncObjs,

  //MyUnits

  uHTTP_ConnectionParams, uHTTPRequests,uDivideAndGatherFile,uSendFileInChunks,

  Vcl.ComCtrls, Vcl.Buttons, Vcl.AppEvnts,
  Vcl.ExtCtrls, Vcl.Grids, Vcl.DBGrids, System.ImageList, Vcl.ImgList

  // IdSSL, IdSSLOpenSSL
  ;


type
  TVisualFrame_HTTP = class(TFrame)
    OpenDialog: TOpenDialog;
    IdHTTP: TIdHTTP;
    PageControl: TPageControl;
    tsInsertLink: TTabSheet;
    tsMediaLibrary: TTabSheet;
    tsLoadFile: TTabSheet;
    tsLastUploads: TTabSheet;
    bUpload: TButton;
    ApplicationEvents: TApplicationEvents;
    tsTest: TTabSheet;
    bTest: TButton;
    sbUploads: TScrollBox;
    pTopPanelMediaLibrary: TPanel;
    bAdd: TBitBtn;
    bDelete: TBitBtn;
    bPaste: TBitBtn;
    bInsert: TBitBtn;
    bCut: TBitBtn;
    bCopy: TBitBtn;
    bToggleSearchPanel: TBitBtn;
    bToggleSortPanel: TBitBtn;
    pSearchPanel: TPanel;
    pSortPanel: TPanel;
    pNavPanel: TPanel;
    pSearchPanelTop: TPanel;
    pSearchPanelBottom: TPanel;
    pNavPanelButtons: TPanel;
    eAdress: TEdit;
    bSearch: TBitBtn;
    eSearch: TEdit;
    cbExactSearch: TCheckBox;
    bNextSearchResult: TBitBtn;
    bPreviousSearchResult: TBitBtn;
    bHome: TBitBtn;
    bUp: TBitBtn;
    bUpdate: TBitBtn;
    DBGrid1: TDBGrid;
    ilControlButtons: TImageList;
    cbSortParameter: TComboBox;
    cbSortDirection: TComboBox;
    bSort: TBitBtn;
    tsKeep2Share: TTabSheet;
    mLinks: TMemo;
    pTopPanelK2S: TPanel;
    bUploadOnKeep2Share: TButton;
    bGetFirstLinkExample: TButton;
    procedure FrameResize(Sender: TObject);
    procedure bUploadClick(Sender: TObject);
    procedure bTestClick(Sender: TObject);
    procedure ApplicationEventsException(Sender: TObject; E: Exception);
    procedure bAllFilesClick(Sender: TObject);
    procedure bUploadOnKeep2ShareClick(Sender: TObject);
    procedure bGetFirstLinkExampleClick(Sender: TObject);



  private
    { Private declarations }

    //Fields
    FHTTP_ConnectionParams:THTTP_ConnectionParams;
    FHTTPServerToRequest:string;

    FHTTPRequests:THTTPRequests;

    FCS:TCriticalSection;
    FCS2:TCriticalSection;

    FLinksOnKeep2Share:TStringList;

    FFilesSL:TStringList;

    FSendFileInChunks:TSendFileInChunks;

    //Events
    FOnKeep2ShareStartUpload:TNotifyEvent;
    FOnKeep2ShareEndUpload:TNotifyEvent;

    procedure CenterButton;
    {< centering some visual elements relatively to self}

    procedure CreateDirOnServerExample;
    {< this is example how to create dir on Server}

    procedure DivideFileExample;
    {< this is example how to divide dir on Server}

    procedure GatherFileFromChunksExample;
    {< this is example how to gather dir on Server}

    procedure SendChunksInfo;
    {< this example how to Send Chunks Info}

    procedure SendFilesInChunks;
    {< this will send file in chunks, no limitation in size in theory
    'cause it uses tfilestream instead of tmemory stream}

    procedure SendOneFile;
    {<will send one file to HTTP Server
    There is a Limit of File Size Here, Limit of MemoryStream on Decode Method On Server
    }

    procedure SendManyFiles;
    procedure UploadInChunks(Sender: TObject; ACountBytes: Int64);
    {< this will send many files, one by one to HTTP Server,
    There is a Limit of File Size Here, Limit of MemoryStream on Decode Method On Server
    }



  public
    { Public declarations }


   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;

   procedure DefineServerToRequest;
   {< this will define Server To Request like

   FHTTPServerToRequest := Protocol + '://' + Host + ':' + Port;
   we define it in one unit and can use in different one

   }


   //properties

   {Connection property}
   property HTTP_ConnectionParams:THTTP_ConnectionParams read
   FHTTP_ConnectionParams write FHTTP_ConnectionParams;

   property HTTPServerToRequest:string read FHTTPServerToRequest
   write FHTTPServerToRequest;

   property  CS:TCriticalSection read  FCS write  FCS;

   property  CS2:TCriticalSection read FCS2 write FCS2;

   property LinksOnKeep2Share:TStringList read FLinksOnKeep2Share write FLinksOnKeep2Share;

   property SendFileInChunks:TSendFileInChunks
   read FSendFileInChunks write FSendFileInChunks;

   property OnKeep2ShareEndUpload:TNotifyEvent
   read FOnKeep2ShareEndUpload write FOnKeep2ShareEndUpload;

   property FilesSL:TStringList read FFilesSL write FFilesSL;

   property OnKeep2ShareStartUpload:TNotifyEvent read FOnKeep2ShareStartUpload
   write FOnKeep2ShareStartUpload;

  end;

implementation

{$R *.dfm}

uses

//My Units
uCreateUniqueName,uSendManyFilesInChunks, uSendFileInChunksThread;

var FSendManyFilesInChunks_UnitVar:TSendManyFilesInChunks;

procedure TVisualFrame_HTTP.ApplicationEventsException(Sender: TObject; E: Exception);
begin

if (Sender is TSendFileInChunksThread) then

begin

      ShowMessage(

      'Error Raised '+E.ClassName+'Error Message : '+
                  E.Message

                  );

end;



end;

procedure TVisualFrame_HTTP.bAllFilesClick(Sender: TObject);
begin

PageControl.ActivePageIndex:=1;

end;

procedure TVisualFrame_HTTP.bGetFirstLinkExampleClick(Sender: TObject);
begin

if FFilesSL.Count>0 then

ShowMessage(
FLinksOnKeep2Share.Values[FFilesSL[0]]
);



end;

procedure TVisualFrame_HTTP.bTestClick(Sender: TObject);

var SendFileInChunksThread:TSendFileInChunksThread;


    FilesSL:TStringList;

begin



if OpenDialog.Execute then
 begin

   FilesSL:=TStringList.Create;

   FilesSL.Assign(OpenDialog.Files);

   FSendManyFilesInChunks_UnitVar.SendFilesOnServer(FilesSL);

   FilesSL.Free;

 end;




end;

procedure TVisualFrame_HTTP.bUploadClick(Sender: TObject);
var SendFileInChunksThread:TSendFileInChunksThread;


    FilesSL:TStringList;

begin

FSendManyFilesInChunks_UnitVar.IsKeep2Share:=false;
FSendManyFilesInChunks_UnitVar.VisualMode:=true;

if OpenDialog.Execute then
 begin

   FilesSL:=TStringList.Create;

   FilesSL.Assign(OpenDialog.Files);

   FSendManyFilesInChunks_UnitVar.SendFilesOnServer(FilesSL);

   FilesSL.Free;

 end;




end;

procedure TVisualFrame_HTTP.CenterButton;
begin

 bUpload.Left:=trunc(Self.width/2-bUpload.width/2);
 bUpload.Top:=trunc(Self.Height/2-bUpload.height/2);

end;

constructor TVisualFrame_HTTP.Create(AOwner: TComponent);
begin
  inherited;


IdHTTP.ConnectTimeout:=5*60000; // 5 minutes for big files
IdHTTP.ReadTimeout:=5*60000;  // 5 minutes for big files

FHTTP_ConnectionParams:=THTTP_ConnectionParams.Create(Self);
FHTTPRequests:=THTTPRequests.Create(Self);

FLinksOnKeep2Share:=TStringList.Create;

FSendFileInChunks:=TSendFileInChunks.Create(Self);
FSendManyFilesInChunks_UnitVar:=TSendManyFilesInChunks.Create(Self);
FSendManyFilesInChunks_UnitVar.SendFileInChunks:=FSendFileInChunks;

// FCS:=TCriticalSection.Create;
 FCS2:=TCriticalSection.Create;

CenterButton;

FFilesSL:=TStringList.Create;




//IdHTTP.ReadTimeout:=30000;


// Assigning pictures to buttons on pNavPanelButtons

pNavPanelButtons.ShowCaption:=false;
bHome.Caption:='';
bUp.Caption:='';
bUpdate.Caption:='';

ilControlButtons.GetBitmap(0,bHome.Glyph);
ilControlButtons.GetBitmap(1,bUp.Glyph);
ilControlButtons.GetBitmap(2,bUpdate.Glyph);


end;

//-------------------------------------
{
destructor TVisualFrame_HTTP.Destroy;
begin

inherited;


end;

}

procedure TVisualFrame_HTTP.SendChunksInfo;
var
  ChunksDir: string;
begin
  ChunksDir := ExtractFilePath(Application.ExeName) + 'DividedFile';
  FHTTPRequests.SendChunksInfo(ChunksDir, '', 0);
end;

procedure TVisualFrame_HTTP.GatherFileFromChunksExample;
var
  ChunksDir: string;
  DivideAndGatherFile: TDivideAndGatherFile;
begin
  ChunksDir := ExtractFilePath(Application.ExeName) + 'DividedFile' + '\';
  DivideAndGatherFile := TDivideAndGatherFile.Create(Self);
  DivideAndGatherFile.GatherFileFromChunks(ChunksDir, 'GatheredFile', 'GatheredFile.txt');
end;

procedure TVisualFrame_HTTP.DivideFileExample;
var
  DivideAndGatherFile: TDivideAndGatherFile;
  dirForChunks: string;
begin
  DivideAndGatherFile := TDivideAndGatherFile.Create(Self);
  dirForChunks := ExtractFilePath(Application.ExeName) + 'DividedFile' + '\';
  if not TDirectory.Exists(dirForChunks) then
    TDirectory.CreateDirectory(dirForChunks);
  if OpenDialog.Execute then
  begin
    DivideAndGatherFile.DivideFileInChunks(OpenDialog.FileName, 1048576, // 1024*1024 <<<ChunkSize
    dirForChunks);
  end;
end;

procedure TVisualFrame_HTTP.FrameResize(Sender: TObject);
begin
CenterButton;
end;

procedure TVisualFrame_HTTP.CreateDirOnServerExample;
var
  MyServerResponse: string;
begin
  //ShowMessage(IdHTTP.Version);
  FHTTPRequests.CreateDirOnServer('public\files\SomeUser_ID123\2016\11\5\temp\23', MyServerResponse);
end;

procedure TVisualFrame_HTTP.SendManyFiles;
var
  FilePathesSL: TStringList;
  FilesSDA: TStringDynArray;
  FilePath: string;
  i: Integer;
begin
  FilePathesSL := TStringList.Create;
  FilesSDA := TDirectory.GetFiles('DividedFile');
  FilePath := ExtractFilePath(Application.ExeName);
  for i := 0 to High(FilesSDA) do
    FilePathesSL.Add(FilePath + FilesSDA[i]);
  FHTTPRequests.SendManyFiles(FilePathesSL, 'SomeDir');
  FreeAndNil(FilePathesSL);
end;

procedure TVisualFrame_HTTP.SendOneFile;
var
  StandartServerResponse: string;
  MyServerResponse: string;
begin
  if OpenDialog.Execute then
    FHTTPRequests.SendOneFile(OpenDialog.FileName, 'SomeDir', StandartServerResponse, MyServerResponse);
  ShowMessage(StandartServerResponse + ''#13''#10'' + MyServerResponse);
end;



procedure TVisualFrame_HTTP.bUploadOnKeep2ShareClick(Sender: TObject);

var FilesSL:TStringList; i:integer;

begin

FSendManyFilesInChunks_UnitVar.IsKeep2Share:=true;
FSendManyFilesInChunks_UnitVar.VisualMode:=false;


if OpenDialog.Execute then
 begin

   FilesSL:=TStringList.Create;
   FilesSL.Assign(OpenDialog.Files);

   for i := 0 to FilesSL.Count-1 do
   FFilesSL.Add(FilesSL[i]);

   FSendManyFilesInChunks_UnitVar.SendFilesOnServer(FilesSL);

   FilesSL.Free;

 end;




end;

//-----------------------------------------------


procedure TVisualFrame_HTTP.DefineServerToRequest;
begin
  // Defining Server To Request
  with FHTTP_ConnectionParams do
  begin
    FHTTPServerToRequest := Protocol + '://' + Host + ':' + Port;
  end;
  //for example like http://localhost:40000
end;

destructor TVisualFrame_HTTP.Destroy;
begin
//FreeAndNil(FHTTP_ConnectionParams); // will be deleted automatically

//FreeAndNil(FCS);
FreeAndNil(FCS2);
FreeAndNil(FLinksOnKeep2Share);
FreeAndNil(FFilesSL);

  inherited;
end;

//-----------------------------------------------

procedure TVisualFrame_HTTP.SendFilesInChunks;
var
  SendFileInChunks: TSendFileInChunks;
begin



  if OpenDialog.Execute then
  begin
    SendFileInChunks := TSendFileInChunks.Create(Self);

     SendFileInChunks.OnUploadInChunks:=UploadInChunks;


       SendFileInChunks.SendFileInChunks(OpenDialog.FileName,
       1048576  // 1024*1024 <<<ChunkSize);
       );
  end;

end;

procedure TVisualFrame_HTTP.UploadInChunks(Sender: TObject; ACountBytes: Int64);
begin

ShowMessage('WOW !!! OnUpload Event is Fired Hello it is Ok It is very Ok.  '+#13#10
+'Bytes Sent '+ACountBytes.ToString());

end;



//-------------------------------------

end.
