unit uDataBaseUnitServer;

interface

uses
  System.SysUtils, System.Classes, FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf,
  FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.VCLUI.Wait, Data.DB,
  FireDAC.Comp.Client, FireDAC.Phys.MySQLDef, FireDAC.Phys.MySQL,Vcl.Dialogs;

type
  TDataBaseUnitServer = class(TDataModule)
    FDConnection: TFDConnection;
    FDPhysMySQLDriverLink: TFDPhysMySQLDriverLink;

  private
    { Private declarations }

    FDataBase:string;
    FPassword:string;
    FUser_Name:string;
    FPort:string;
    FServer:string;
    FCharacterSet:string;

  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;

    function Connect:Boolean;


    property DataBase:string read FDataBase write FDataBase;
    property Password:string read FPassword write FPassword;
    property User_Name:string read FUser_Name write FUser_Name;
    property Port:string read FPort write FPort;
    property Server:string read FServer write FServer;
    property CharacterSet:string read FCharacterSet write FCharacterSet;

  end;

var
  DataBaseUnitServer: TDataBaseUnitServer;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TDataBaseUnitServer }

function TDataBaseUnitServer.Connect: Boolean;
var oParams:TStrings;  ErrorInfo:string;

begin



 oParams:=TStringList.Create;


 try

  oParams.Add('DataBase='+FDataBase);
  oParams.Add('Password='+FPassword);
  oParams.Add('User_Name='+FUser_Name);
  oParams.Add('Port='+FPort);
  oParams.Add('Server='+FServer);
  oParams.Add('CharacterSet='+FCharacterSet);

  FDConnection.Params.Assign(oParams);
  FDConnection.DriverName:='MySQL';


   // 

   try

   FDConnection.Connected:=true;

   if FDConnection.Connected then

     begin
     Result:=true;

//     showmessage('Connected');
     end else Result:=false;



   except



   on E: EFDDBEngineException do

    case E.Kind of
    ekUserPwdInvalid:


       // user name or password are incorrect
       raise Exception.Create('DBConnection Error. User name or password are incorrect'+
       #13#10+#13#10+E.ClassName+'  ,   : '+E.Message);



    ekUserPwdExpired:


      raise Exception.Create('DBConnection Error. User password is expired'
    +#13#10+#13#10+E.ClassName+'  ,   : '+E.Message);



    ekServerGone:



      raise Exception.Create('DBConnection Error. DBMS is not accessible due to some reason'
      +#13#10+#13#10+E.ClassName+'  ,   : '+E.Message);




    else                // other issues



      raise Exception.Create('DBConnection Error. UnknownMistake'
      +#13#10+#13#10+E.ClassName+'  ,   : '+E.Message);





    end;

    on E : Exception do

      raise Exception.Create(
      E.ClassName+'  ,   : '+#13#10+#13#10+E.Message
      );





   end;




 finally

  FreeAndNil(oParams);

 end;


end;

constructor TDataBaseUnitServer.Create(AOwner: TComponent);
begin
  inherited;

  // values by default - they can be overriden from outside
    FDataBase:='coffeetest_db';
    FPassword:='masterkey';
    FUser_Name:='root';
    FPort:='3306';
    FServer:='localhost';
    FCharacterSet:='utf8';


end;

end.
