unit uTestHTTPClient;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, uPS_HTTPClient_Main, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.VCLUI.Wait, Data.DB, FireDAC.Comp.Client, Vcl.StdCtrls;

type
  TfTestHTTPClient = class(TForm)
    bUpload2Keep2Share: TButton;
    memo: TMemo;
    bGetExample: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bUpload2Keep2ShareClick(Sender: TObject);
    procedure bGetExampleClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
   PS_HTTPClient1:TPS_HTTPClient;

    procedure UploadInChunksEnd(Sender:TObject; ACountBytes:Int64);
    procedure OnKeep2ShareEndUpload(Sender:TObject);
    procedure OnKeep2ShareStartUpload(Sender:TObject);



  public
    { Public declarations }



  end;

var
  fTestHTTPClient: TfTestHTTPClient;

implementation

{$R *.dfm}

procedure TfTestHTTPClient.bGetExampleClick(Sender: TObject);
begin

if PS_HTTPClient1.VisualFrame.FilesSL.Count>0 then

ShowMessage(
PS_HTTPClient1.VisualFrame.LinksOnKeep2Share.Values[PS_HTTPClient1.VisualFrame.FilesSL[0]]
);


end;

procedure TfTestHTTPClient.bUpload2Keep2ShareClick(Sender: TObject);
begin
//

PS_HTTPClient1.VisualFrame.bUploadOnKeep2ShareClick(Self);

end;

procedure TfTestHTTPClient.FormCreate(Sender: TObject);
begin


ReportMemoryLeaksOnShutdown:=true; // small memory leaks in code

PS_HTTPClient1:=TPS_HTTPClient.Create(Self);
//PS_HTTPClient1.VisualFrame.SendFileInChunks.OnUploadInChunksEnd:=UploadInChunksEnd;
PS_HTTPClient1.VisualFrame.OnKeep2ShareStartUpload:= OnKeep2ShareStartUpload;
PS_HTTPClient1.VisualFrame.OnKeep2ShareEndUpload:= OnKeep2ShareEndUpload;

// defining HTTP_ConnectionParams and Server To Request

    with PS_HTTPClient1.visualFrame do begin

      with HTTP_ConnectionParams do begin

      Protocol:='http';
      Host:='localhost';//'40.85.142.196';//'192.168.1.102';//'localhost';
      Port:='40000';
      IdUser:='123';
      User:='SomeUser';

      end;

      DefineServerToRequest;

    end;

end;

procedure TfTestHTTPClient.FormDestroy(Sender: TObject);
begin
PS_HTTPClient1.Free; // << must be to avoid memory leaks
end;

procedure TfTestHTTPClient.OnKeep2ShareEndUpload(Sender: TObject);
begin

memo.Lines.Add('Upload attempt finished ');

if PS_HTTPClient1.VisualFrame.LinksOnKeep2Share.Count>0 then
memo.Lines.Add(PS_HTTPClient1.VisualFrame.
LinksOnKeep2Share[PS_HTTPClient1.VisualFrame.LinksOnKeep2Share.Count-1]);


end;

procedure TfTestHTTPClient.OnKeep2ShareStartUpload(Sender: TObject);
begin

memo.Lines.Add('   ');
memo.Lines.Add('Upload attempt started');

end;

procedure TfTestHTTPClient.UploadInChunksEnd(Sender: TObject; ACountBytes: Int64);
begin


end;

end.
